##############################################################################
# IS4523 Workstation Setup Script
# Purpose: Configures system with all required software for IS4523 
# Author:  Jacob Stauffer | CISSP
##############################################################################
<#
.SYNOPSIS
    IS4523 Workstation Setup Script
.DESCRIPTION
    This script will configure system with all required software for IS4523.
.EXAMPLE
    is4523.ps1
#>

param (
    [Parameter()]
    [string]$bannertitle="Legal Notice",
    [Parameter()]
    [string]$bannercontent="This workstation should only be used for authorized use only.  Unauthorized use is prohibited.  Unauthorized use of this workstation may result in disciplinary action, civil and/or criminal penalties.  By continuing to use this workstation you agree to abide by all applicable laws and regulations.",
    [Parameter()]
    [string]$tooldir="$env:SystemDrive\Tools"
)

$ErrorActionPreference = "SilentlyContinue"
$ProgressPreference = "SilentlyContinue"

function Build-CourseFolders () {
    $folders = @(
        "Cases",
        "Evidence"
    )
    $links = @(
        [pscustomobject]@{Target="C:\Tools";DestPath="Tools"}
    )
    foreach ($folder in $folders) {
        if (!(Test-Path $folder)) {
            New-Item -ItemType Directory -Force -Path $env:USERPROFILE\Desktop\$folder
        }
    }
    foreach ($link in $links) {
        if (!(Test-Path $env:USERPROFILE\Desktop\$link[1])) {
            $path = Join-Path -Path $env:USERPROFILE\Desktop -ChildPath $link.DestPath
            New-Item -ItemType SymbolicLink -Path $path -Target $link.Target
        }
    }
}
function Expand-ThirdPartyArchivedApplication ($url, $destination, $dirname, $name="archive.zip") {
    Write-Host "[+] Downloading and Installing $url" -ForegroundColor Green
    Invoke-WebRequest -Uri $url -OutFile $env:TEMP\$name -UseBasicParsing
    Expand-Archive -Path $env:TEMP\$name -DestinationPath $destination\$dirname
    Remove-Item $env:TEMP\$name
}

function Install-ThirdPartyApplication ($url, $name="installer.exe", $dir=$env:TEMP, $delete=$true) {
    Write-Host "[+] Downloading and Installing $url" -ForegroundColor Green
    Invoke-WebRequest -Uri $url -OutFile $dir\$name -UseBasicParsing
    Start-Process -FilePath $name -ArgumentList "/S /v/qn" -WorkingDirectory $dir -Wait
    if ($delete) {
        Remove-Item "$dir\$name"
    }
}

function Install-ThirdPartyArchivedApplicationPSScript ($url, $name="archive.zip", $execute="", $arguments="") {
    Write-Host "[+] Downloading and Installing $url" -ForegroundColor Green
    Invoke-WebRequest -Uri $url -OutFile $env:TEMP\$name -UseBasicParsing
    Expand-Archive -Path $env:TEMP\$name -DestinationPath $env:TEMP
    powershell "& ""$env:TEMP\$execute $arguments"""
}

function Set-EnvironmentVariables () {
    $paths = @(
        "C:\Tools",
        "C:\Tools\chainsaw",
        "C:\Tools\hayabusa",
        "C:\Tools\WinHex",
        "C:\Tools\sleuthkit\bin",
        "C:\Tools\sysinternals",
        "C:\Tools\ZimmermanTools"
    )
    Write-Host "[+] Setting Environment Variables" -ForegroundColor Green
    foreach ($path in $paths) {
        try {
            $env:Path = $env:Path + ";" + $path
        } catch {
            Write-Host "[*] Failed to add $path to $env:Path" -ForegroundColor Red
        }
    }
}

# Setting the windows login banner
Write-Host "[+] Setting the windows login banner..." -ForegroundColor Green
Set-ItemProperty -Path "HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System" -Name "legalnoticecaption" -Value $bannertitle
Set-ItemProperty -Path "HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System" -Name "legalnoticetext" -Value $bannercontent

# Enable Windows dark mode
Write-Host "[+] Enabling dark mode..." -ForegroundColor Green
Set-ItemProperty -Path HKCU:\Software\Microsoft\Windows\CurrentVersion\Themes\Personalize -Name "AppsUseLightTheme" -Value 0

# Set-WindowsExplorerOptions -EnableShowHiddenFilesFoldersDrives -EnableShowProtectedOSFiles -EnableShowFileExtensions
# Set-BoxStarterTaskbarOptions -Size Small -Dock Bottom -Combine Full -AlwaysShowIconsOn

# Creating tools directory
Write-Host "[+] Creating tools directory..." -ForegroundColor Green
if (-Not (Test-Path -Path $tooldir)) {
    Write-Host "`tCreating tools directory"
    New-Item -Path $tooldir -Type Directory
}

# Installing third-party applications not in Choco
Install-ThirdPartyApplication -url "https://cc-public.s3.amazonaws.com/AccessData_FTK_Imager_4.5.0_(x64).exe"
Install-ThirdPartyArchivedApplicationPSScript -url "https://f001.backblazeb2.com/file/EricZimmermanTools/Get-ZimmermanTools.zip" -execute "Get-ZimmermanTools.ps1" -arguments "-Dest $tooldir\ZimmermanTools"
Expand-ThirdPartyArchivedApplication -url "https://x-ways.net/winhex.zip" -destination $tooldir -dirname "WinHex"
Expand-ThirdPartyArchivedApplication -url "https://cc-public.s3.amazonaws.com/kape.zip" -destination $tooldir -dirname "Kape"
Expand-ThirdPartyArchivedApplication -url "https://cc-public.s3.amazonaws.com/arsenal.zip" -destination $tooldir -dirname "Arsenal Image Mounter"

& C:\Tools\Kape\Kape\Get-KAPEUpdate.ps1
& C:\Tools\Kape\Kape\kape.exe --sync

# Install OpenSSH client
Write-Host "[+] Installing OpenSSH Client..." -ForegroundColor Green
Get-WindowsCapability -Online | Where-Object { $_.Name -like "OpenSSH.Client*" } | Add-WindowsCapability -Online | Out-Null

choco install 7zip -y
choco install autopsy -y
choco install firefox -y
choco install git -y
choco install powershell-core -y
choco install microsoft-windows-terminal -y
choco install nerd-fonts-hack -y
choco install libreoffice-fresh -y
choco install pestudio -y
choco install processhacker -y
choco install powertoys -y
choco install python3 -y
choco install jq -y
choco install starship -y
choco install sysinternals --params "/InstallDir:C:\Tools\sysinternals" -y
choco install vscode -y

# Install my DFIR-PSTools
cd \Tools
git clone https://gitlab.com/jknyght9/DFIR-PSTools.git
echo "Import-Module C:\Tools\DFIR-PSTools\DFIR-PSTools.psm1\n" >> $profile.AllUsersAllHosts

# Install up to date tools
Invoke-WebRequest -Uri ((Invoke-WebRequest -Uri https://api.github.com/repos/Yamato-Security/hayabusa/releases/latest).Content | jq -r '.assets[] | select(.name | contains ("win-64")) | .browser_download_url') -OutFile $tooldir\hayabusa.zip
Expand-Archive -Path $tooldir\hayabusa.zip -DestinationPath $tooldir\hayabusa
Move-Item $tooldir\hayabusa\hayabusa*.exe $tooldir\hayabusa\hayabusa.exe
Invoke-WebRequest -Uri ((Invoke-WebRequest -Uri https://api.github.com/repos/mandiant/capa/releases/latest).Content | jq -r '.assets[] | select(.name | contains ("win")) | .browser_download_url') -OutFile $tooldir\capa.zip
Expand-Archive -Path $tooldir\capa.zip -DestinationPath $tooldir\
Invoke-WebRequest -Uri ((Invoke-WebRequest -Uri https://api.github.com/repos/mandiant/flare-floss/releases/latest).Content | jq -r '.assets[] | select(.name | contains ("win")) | .browser_download_url') -OutFile $tooldir\floss.zip
Expand-Archive -Path $tooldir\floss.zip -DestinationPath $tooldir\
Invoke-WebRequest -Uri ((Invoke-WebRequest -Uri https://api.github.com/repos/WithSecureLabs/chainsaw/releases/latest).Content | jq -r '.assets[] | select(.name | contains ("examples")) | .browser_download_url') -OutFile $tooldir\chainsaw.zip 
Expand-Archive -Path $tooldir\chainsaw.zip -DestinationPath $tooldir\
Move-Item $tooldir\chainsaw\chainsaw_x86_64-pc-windows-msvc.exe $tooldir\chainsaw\chainsaw.exe
Invoke-WebRequest -Uri ((Invoke-WebRequest -Uri https://api.github.com/repos/sleuthkit/sleuthkit/releases/latest).Content | jq -r '.assets[] | select(.name | contains ("asc") | not) | select(.name | contains ("win")) | .browser_download_url') -OutFile $tooldir\sleuthkit.zip
Expand-Archive -Path $tooldir\sleuthkit.zip -DestinationPath $tooldir
Move-Item $tooldir\sleuthkit* $tooldir\sleuthkit

Remove-Item $tooldir\hayabusa.zip
Remove-Item $tooldir\capa.zip
Remove-Item $tooldir\floss.zip
Remove-Item $tooldir\chainsaw.zip
Remove-Item $tooldir\sleuthkit.zip
Invoke-WebRequest -Uri "https://raw.githubusercontent.com/AndrewRathbun/DFIRPowerShellScripts/main/Get-ChainsawSigmaRules.ps1" -OutFile $tooldir\Get-ChainsawSigmaRules.ps1 -UseBasicParsing
& $tooldir\Get-ChainsawSigmaRules.ps1

# Set wallpaper
Copy-Item -Path "BGInfo" -Destination $tooldir\BGInfo -Recurse
Set-ItemProperty -Path HKLM:\Software\Microsoft\Windows\CurrentVersion\Run -Name "BGInfo" -Value "powershell & C:\Tools\sysinternals\Bginfo64.exe C:\Tools\BGInfo\background.bgi /timer:0 /silent /nolicprompt"

# Set starship in Powershell profile
echo "Invoke-Expression (&starship init powershell)\n" >> $profile.AllUsersAllHosts

# Move Public Profile Shortcuts to tools folder
Write-Host "[+] Moving Public Profile Shortcuts to tools folder..." -ForegroundColor Green
Move-Item -Path $env:PUBLIC\Desktop\* -Destination $tooldir
Move-Item -Path $env:USERPROFILE\Desktop\*.lnk -Destination $tooldir
New-Item -ItemType SymbolicLink -Path $tooldir\PEStudio -Target $env:ALLUSERSPROFILE\chocolatey\bin\pestudio.exe

# Set environment variables and course folders
Write-Host "[+] Setting environment variables and course folders..." -ForegroundColor Green
Set-EnvironmentVariables
Build-CourseFolders

# Setting taskbar with Terminal and Explorer icons
# https://stackoverflow.com/questions/6551224/how-to-set-a-binary-registry-value-reg-binary-with-powershell
Write-Host "[+] Setting taskbar with Terminal and Explorer icons..." -ForegroundColor Green
Set-ItemProperty -Path "HKCU:\Software\Microsoft\Windows\CurrentVersion\Explorer\Taskband" -Name "Favorites" -Type Binary -Value ([byte[]](0x00,0x05,0x06,0x00,0x00,0x14,0x00,0x1f,0x80,0x9b,0xd4,0x34,0x42,0x45,0x02,0xf3,0x4d,0xb7,0x80,0x38,0x93,0x94,0x34,0x56,0xe1,0xef,0x05,0x00,0x00,0xed,0x04,0x41,0x50,0x50,0x53,0xdb,0x04,0x08,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6b,0x02,0x00,0x00,0x31,0x53,0x50,0x53,0x55,0x28,0x4c,0x9f,0x79,0x9f,0x39,0x4b,0xa8,0xd0,0xe1,0xd4,0x2d,0xe1,0xd5,0xf3,0x61,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x28,0x00,0x00,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x19,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x85,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x3a,0x00,0x00,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x31,0x00,0x2e,0x00,0x31,0x00,0x33,0x00,0x2e,0x00,0x31,0x00,0x31,0x00,0x34,0x00,0x33,0x00,0x31,0x00,0x2e,0x00,0x30,0x00,0x5f,0x00,0x78,0x00,0x36,0x00,0x34,0x00,0x5f,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x00,0x00,0x69,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x2c,0x00,0x00,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x21,0x00,0x41,0x00,0x70,0x00,0x70,0x00,0x00,0x00,0xc1,0x00,0x00,0x00,0x0f,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x57,0x00,0x00,0x00,0x43,0x00,0x3a,0x00,0x5c,0x00,0x50,0x00,0x72,0x00,0x6f,0x00,0x67,0x00,0x72,0x00,0x61,0x00,0x6d,0x00,0x20,0x00,0x46,0x00,0x69,0x00,0x6c,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x41,0x00,0x70,0x00,0x70,0x00,0x73,0x00,0x5c,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x31,0x00,0x2e,0x00,0x31,0x00,0x33,0x00,0x2e,0x00,0x31,0x00,0x31,0x00,0x34,0x00,0x33,0x00,0x31,0x00,0x2e,0x00,0x30,0x00,0x5f,0x00,0x78,0x00,0x36,0x00,0x34,0x00,0x5f,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x00,0x00,0x00,0x00,0x1d,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x00,0x48,0x00,0x00,0x00,0xba,0xb3,0x52,0x2b,0xaf,0x42,0x53,0x41,0xb4,0xfb,0x0d,0x29,0x27,0xa3,0xa4,0x46,0x00,0x00,0x00,0x00,0xcd,0x01,0x00,0x00,0x31,0x53,0x50,0x53,0x4d,0x0b,0xd4,0x86,0x69,0x90,0x3c,0x44,0x81,0x9a,0x2a,0x54,0x09,0x0d,0xcc,0xec,0x4d,0x00,0x00,0x00,0x0c,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x1d,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x53,0x00,0x71,0x00,0x75,0x00,0x61,0x00,0x72,0x00,0x65,0x00,0x31,0x00,0x35,0x00,0x30,0x00,0x78,0x00,0x31,0x00,0x35,0x00,0x30,0x00,0x4c,0x00,0x6f,0x00,0x67,0x00,0x6f,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x49,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x1b,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x53,0x00,0x71,0x00,0x75,0x00,0x61,0x00,0x72,0x00,0x65,0x00,0x34,0x00,0x34,0x00,0x78,0x00,0x34,0x00,0x34,0x00,0x4c,0x00,0x6f,0x00,0x67,0x00,0x6f,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x49,0x00,0x00,0x00,0x0d,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x1b,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x57,0x00,0x69,0x00,0x64,0x00,0x65,0x00,0x33,0x00,0x31,0x00,0x30,0x00,0x78,0x00,0x31,0x00,0x35,0x00,0x30,0x00,0x4c,0x00,0x6f,0x00,0x67,0x00,0x6f,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x00,0x78,0xd7,0xff,0x11,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x3d,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x4c,0x00,0x61,0x00,0x72,0x00,0x67,0x00,0x65,0x00,0x54,0x00,0x69,0x00,0x6c,0x00,0x65,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0xa1,0x04,0x00,0x00,0x25,0x00,0x00,0x00,0x0b,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x09,0x00,0x00,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x00,0x00,0x00,0x00,0x3d,0x00,0x00,0x00,0x14,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x53,0x00,0x6d,0x00,0x61,0x00,0x6c,0x00,0x6c,0x00,0x54,0x00,0x69,0x00,0x6c,0x00,0x65,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x00,0x00,0x31,0x53,0x50,0x53,0xb1,0x16,0x6d,0x44,0xad,0x8d,0x70,0x48,0xa7,0x48,0x40,0x2e,0xa4,0x3d,0x78,0x8c,0x15,0x00,0x00,0x00,0x64,0x00,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x44,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x00,0x00,0x31,0x53,0x50,0x53,0x30,0xf1,0x25,0xb7,0xef,0x47,0x1a,0x10,0xa5,0xf1,0x02,0x60,0x8c,0x9e,0xeb,0xac,0x25,0x00,0x00,0x00,0x0a,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x09,0x00,0x00,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2d,0x00,0x00,0x00,0x31,0x53,0x50,0x53,0xb3,0x77,0xed,0x0d,0x14,0xc6,0x6c,0x45,0xae,0x5b,0x28,0x5b,0x38,0xd7,0xb0,0x1b,0x11,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x64,0x00,0x00,0x00,0x1d,0x00,0xef,0xbe,0x02,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x21,0x00,0x41,0x00,0x70,0x00,0x70,0x00,0x00,0x00,0xf3,0x04,0x12,0x00,0x00,0x00,0x2b,0x00,0xef,0xbe,0x81,0x0e,0x00,0x26,0x0c,0x72,0xd8,0x01,0xf3,0x04,0x64,0x00,0x00,0x00,0x1d,0x00,0xef,0xbe,0x02,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x21,0x00,0x41,0x00,0x70,0x00,0x70,0x00,0x00,0x00,0xf3,0x04,0x22,0x00,0x00,0x00,0x1e,0x00,0xef,0xbe,0x02,0x00,0x55,0x00,0x73,0x00,0x65,0x00,0x72,0x00,0x50,0x00,0x69,0x00,0x6e,0x00,0x6e,0x00,0x65,0x00,0x64,0x00,0x00,0x00,0xf3,0x04,0x00,0x00,0xff))
Set-ItemProperty -Path "HKCU:\Software\Microsoft\Windows\CurrentVersion\Explorer\Taskband" -Name "FavoritesResolve" -Type Binary -Value ([byte[]](0x57,0x06,0x00,0x00,0x4c,0x00,0x00,0x00,0x01,0x14,0x02,0x00,0x00,0x00,0x00,0x00,0xc0,0x00,0x00,0x00,0x00,0x00,0x00,0x46,0x81,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0x06,0x14,0x00,0x1f,0x80,0x9b,0xd4,0x34,0x42,0x45,0x02,0xf3,0x4d,0xb7,0x80,0x38,0x93,0x94,0x34,0x56,0xe1,0xef,0x05,0x00,0x00,0xed,0x04,0x41,0x50,0x50,0x53,0xdb,0x04,0x08,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6b,0x02,0x00,0x00,0x31,0x53,0x50,0x53,0x55,0x28,0x4c,0x9f,0x79,0x9f,0x39,0x4b,0xa8,0xd0,0xe1,0xd4,0x2d,0xe1,0xd5,0xf3,0x61,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x28,0x00,0x00,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x19,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x85,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x3a,0x00,0x00,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x31,0x00,0x2e,0x00,0x31,0x00,0x33,0x00,0x2e,0x00,0x31,0x00,0x31,0x00,0x34,0x00,0x33,0x00,0x31,0x00,0x2e,0x00,0x30,0x00,0x5f,0x00,0x78,0x00,0x36,0x00,0x34,0x00,0x5f,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x00,0x00,0x69,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x2c,0x00,0x00,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x21,0x00,0x41,0x00,0x70,0x00,0x70,0x00,0x00,0x00,0xc1,0x00,0x00,0x00,0x0f,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x57,0x00,0x00,0x00,0x43,0x00,0x3a,0x00,0x5c,0x00,0x50,0x00,0x72,0x00,0x6f,0x00,0x67,0x00,0x72,0x00,0x61,0x00,0x6d,0x00,0x20,0x00,0x46,0x00,0x69,0x00,0x6c,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x41,0x00,0x70,0x00,0x70,0x00,0x73,0x00,0x5c,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x31,0x00,0x2e,0x00,0x31,0x00,0x33,0x00,0x2e,0x00,0x31,0x00,0x31,0x00,0x34,0x00,0x33,0x00,0x31,0x00,0x2e,0x00,0x30,0x00,0x5f,0x00,0x78,0x00,0x36,0x00,0x34,0x00,0x5f,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x00,0x00,0x00,0x00,0x1d,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x00,0x48,0x00,0x00,0x00,0xba,0xb3,0x52,0x2b,0xaf,0x42,0x53,0x41,0xb4,0xfb,0x0d,0x29,0x27,0xa3,0xa4,0x46,0x00,0x00,0x00,0x00,0xcd,0x01,0x00,0x00,0x31,0x53,0x50,0x53,0x4d,0x0b,0xd4,0x86,0x69,0x90,0x3c,0x44,0x81,0x9a,0x2a,0x54,0x09,0x0d,0xcc,0xec,0x4d,0x00,0x00,0x00,0x0c,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x1d,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x53,0x00,0x71,0x00,0x75,0x00,0x61,0x00,0x72,0x00,0x65,0x00,0x31,0x00,0x35,0x00,0x30,0x00,0x78,0x00,0x31,0x00,0x35,0x00,0x30,0x00,0x4c,0x00,0x6f,0x00,0x67,0x00,0x6f,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x49,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x1b,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x53,0x00,0x71,0x00,0x75,0x00,0x61,0x00,0x72,0x00,0x65,0x00,0x34,0x00,0x34,0x00,0x78,0x00,0x34,0x00,0x34,0x00,0x4c,0x00,0x6f,0x00,0x67,0x00,0x6f,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x49,0x00,0x00,0x00,0x0d,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x1b,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x57,0x00,0x69,0x00,0x64,0x00,0x65,0x00,0x33,0x00,0x31,0x00,0x30,0x00,0x78,0x00,0x31,0x00,0x35,0x00,0x30,0x00,0x4c,0x00,0x6f,0x00,0x67,0x00,0x6f,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x00,0x78,0xd7,0xff,0x11,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x3d,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x4c,0x00,0x61,0x00,0x72,0x00,0x67,0x00,0x65,0x00,0x54,0x00,0x69,0x00,0x6c,0x00,0x65,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x11,0x00,0x00,0x00,0x0e,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0xa1,0x04,0x00,0x00,0x25,0x00,0x00,0x00,0x0b,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x09,0x00,0x00,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x00,0x00,0x00,0x00,0x3d,0x00,0x00,0x00,0x14,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x49,0x00,0x6d,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x73,0x00,0x5c,0x00,0x53,0x00,0x6d,0x00,0x61,0x00,0x6c,0x00,0x6c,0x00,0x54,0x00,0x69,0x00,0x6c,0x00,0x65,0x00,0x2e,0x00,0x70,0x00,0x6e,0x00,0x67,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x00,0x00,0x31,0x53,0x50,0x53,0xb1,0x16,0x6d,0x44,0xad,0x8d,0x70,0x48,0xa7,0x48,0x40,0x2e,0xa4,0x3d,0x78,0x8c,0x15,0x00,0x00,0x00,0x64,0x00,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x44,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x00,0x00,0x00,0x31,0x53,0x50,0x53,0x30,0xf1,0x25,0xb7,0xef,0x47,0x1a,0x10,0xa5,0xf1,0x02,0x60,0x8c,0x9e,0xeb,0xac,0x25,0x00,0x00,0x00,0x0a,0x00,0x00,0x00,0x00,0x1f,0x00,0x00,0x00,0x09,0x00,0x00,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2d,0x00,0x00,0x00,0x31,0x53,0x50,0x53,0xb3,0x77,0xed,0x0d,0x14,0xc6,0x6c,0x45,0xae,0x5b,0x28,0x5b,0x38,0xd7,0xb0,0x1b,0x11,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x64,0x00,0x00,0x00,0x1d,0x00,0xef,0xbe,0x02,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x21,0x00,0x41,0x00,0x70,0x00,0x70,0x00,0x00,0x00,0xf3,0x04,0x22,0x00,0x00,0x00,0x1e,0x00,0xef,0xbe,0x02,0x00,0x55,0x00,0x73,0x00,0x65,0x00,0x72,0x00,0x50,0x00,0x69,0x00,0x6e,0x00,0x6e,0x00,0x65,0x00,0x64,0x00,0x00,0x00,0xf3,0x04,0x12,0x00,0x00,0x00,0x2b,0x00,0xef,0xbe,0x81,0x0e,0x00,0x26,0x0c,0x72,0xd8,0x01,0xf3,0x04,0x64,0x00,0x00,0x00,0x1d,0x00,0xef,0xbe,0x02,0x00,0x4d,0x00,0x69,0x00,0x63,0x00,0x72,0x00,0x6f,0x00,0x73,0x00,0x6f,0x00,0x66,0x00,0x74,0x00,0x2e,0x00,0x57,0x00,0x69,0x00,0x6e,0x00,0x64,0x00,0x6f,0x00,0x77,0x00,0x73,0x00,0x54,0x00,0x65,0x00,0x72,0x00,0x6d,0x00,0x69,0x00,0x6e,0x00,0x61,0x00,0x6c,0x00,0x5f,0x00,0x38,0x00,0x77,0x00,0x65,0x00,0x6b,0x00,0x79,0x00,0x62,0x00,0x33,0x00,0x64,0x00,0x38,0x00,0x62,0x00,0x62,0x00,0x77,0x00,0x65,0x00,0x21,0x00,0x41,0x00,0x70,0x00,0x70,0x00,0x00,0x00,0xf3,0x04,0x00,0x00,0x00,0x00,0x00,0x00))
Set-ItemProperty -Path "HKCU:\Software\Microsoft\Windows\Shell\Bags\1\Desktop" -Name "FFLAGS" -Value 1075839525
Stop-Process -Name explorer

Write-Host "[!] All done! MAKE SURE THAT YOU TAKE A SNAPSHOT BEFORE BEGINNING LABS!" -BackgroundColor Green